## START: Set by rpmautospec
## (rpmautospec version 0.3.0)
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 2;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

# The tests work but they rely on strict timing, which makes them flaky when
# run in koji, so keep them disabled for now
%bcond_with tests

# last tagged release is from 2016 despite ongoing development
%global commit 8f01b7558a80e5f08b06244d2821c3eb5c1d6e9b
%global shortcommit %(c=%{commit}; echo ${c:0:7})
%global date 20220708

Name:           wdt
Version:        1.32.1910230^%{?date}git%{?shortcommit}
Release:        %autorelease
Summary:        Warp speed Data Transfer

License:        BSD
URL:            https://www.facebook.com/WdtOpenSource
Source0:        https://github.com/facebook/wdt/archive/%{commit}/%{name}-%{commit}.tar.gz

BuildRequires:  gcc-c++
BuildRequires:  cmake

ExclusiveArch:  x86_64 aarch64 ppc64le

BuildRequires:  boost-devel
BuildRequires:  double-conversion-devel
BuildRequires:  folly-devel
BuildRequires:  gflags-devel
BuildRequires:  glog-devel
BuildRequires:  gtest-devel
BuildRequires:  jemalloc-devel
BuildRequires:  openssl-devel
%if %{with tests}
BuildRequires:  bash
BuildRequires:  python3
%endif

Requires:       %{name}-libs%{?_isa} = %{version}-%{release}
# for wcp
Requires:       bash

%global _description %{expand:
Warp speed Data Transfer is aiming to transfer data between two systems
as fast as possible.}

%description %{_description}


%package        devel
Summary:        Development files for %{name}
Requires:       %{name}-libs%{?_isa} = %{version}-%{release}
Obsoletes:      %{name}-static < 1.32.1910230^20210809git57bbd43-1

%description    devel %{_description}

The %{name}-devel package contains libraries and header files for
developing applications that use %{name}.


%package        libs
Summary:        Shared libraries for %{name}

%description    libs %{_description}

The %{name}-libs package contains libraries for %{name}.


%prep
%setup -c -q
# wdt needs to be build from a base directory called wdt
# https://github.com/facebook/wdt/issues/213
ln -s %{name}-%{commit} %{name}
# Disable hardcoded CXX FLAGS
sed -i -e 's/set(CMAKE_CXX_FLAGS.*//' %{name}/CMakeLists.txt


%build
pushd %{name}
%cmake \
  -DCMAKE_CXX_FLAGS="%{optflags}" \
  -DCMAKE_SKIP_RPATH=ON \
  -DBUILD_SHARED_LIBS=ON \
  -DWDT_USE_SYSTEM_FOLLY=ON \
%if %{with tests}
  -DBUILD_TESTING=ON
%else
  -DBUILD_TESTING=OFF
%endif
%cmake_build
popd


%install
pushd %{name}
%cmake_install
# move installed shared libraries in the right place if needed
%if "%{_lib}" == "lib64"
mv %{buildroot}%{_prefix}/lib %{buildroot}%{_libdir}
%endif
popd


%if %{with tests}
%check
pushd %{_shared_builddir}
# tests are linked against a bunch of shared libraries
export LD_LIBRARY_PATH="$PWD/%{__cmake_builddir}"
%ctest
popd
%endif


%files
%doc wdt/README.md
%license wdt/LICENSE
%{_bindir}/wdt
%{_bindir}/wcp

%files devel
%{_includedir}/*
%{_libdir}/*.so

%files libs
%{_libdir}/*.so.1*


%changelog
* Sat Jul 23 2022 Fedora Release Engineering <releng@fedoraproject.org> 1.32.1910230^20220708git8f01b75-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_37_Mass_Rebuild

* Thu Jul 21 2022 Michel Alexandre Salim <michel@michel-slm.name> 1.32.1910230^20220708git8f01b75-1
- Update to snapshot from 20220708

* Thu Mar 17 2022 Michel Alexandre Salim <salimma@fedoraproject.org> 1.32.1910230^20210809git57bbd43-2
- Rebuilt for folly-2022.03.14.00

* Wed Mar 09 2022 Michel Alexandre Salim <salimma@fedoraproject.org> 1.32.1910230^20210809git57bbd43-1
- Drop static build; temporarily disable on ppc64le until Folly is fixed

* Sat Jan 22 2022 Fedora Release Engineering <releng@fedoraproject.org> 1.32.1910230-17.20210809git57bbd43
- Rebuilt for https://fedoraproject.org/wiki/Fedora_36_Mass_Rebuild

* Sat Dec 25 2021 Michel Alexandre Salim <salimma@fedoraproject.org> 1.32.1910230-16.20210809git57bbd43
- Rebuilt against the 2021.12.20.00 folly stack

* Tue Sep 14 2021 Sahana Prasad <sahana@redhat.com> 1.32.1910230-15.20210809git57bbd43
- Rebuilt with OpenSSL 3.0.0

* Wed Aug 18 2021 Davide Cavalca <dcavalca@fedoraproject.org> 1.32.1910230-14.20210809git57bbd43
- Update to snapshot from 20210809; Fixes: RHBZ#1991103

* Sun Aug  1 2021 Michel Alexandre Salim <salimma@fedoraproject.org> - 1.32.1910230-7.20210726git7c44f79
- Update to snapshot from 20210726

* Fri Jul 23 2021 Fedora Release Engineering <releng@fedoraproject.org> - 1.32.1910230-7.20210625gitb98479c
- Rebuilt for https://fedoraproject.org/wiki/Fedora_35_Mass_Rebuild

* Mon Jul 12 2021 Michel Alexandre Salim <salimma@fedoraproject.org> - 1.32.1910230-6.20210625gitb98479c
- Update to snapshot from 20210625

* Mon May 10 2021 Michel Alexandre Salim <salimma@fedoraproject.org> - 1.32.1910230-6.20210420git0f100c6
- Rebuild against folly 2021.05.10.00

* Mon Apr 26 2021 Michel Alexandre Salim <salimma@fedoraproject.org> - 1.32.1910230-5.20210420git0f100c6
- Update to snapshot from 20210420

* Fri Apr 16 2021 Michel Alexandre Salim <salimma@fedoraproject.org> - 1.32.1910230-5.20210331gitfdbc543
- Update to snapshot from 20210331

* Mon Mar 29 2021 Michel Alexandre Salim <salimma@fedoraproject.org> - 1.32.1910230-5.20210312git97a8c0a
- Rebuild against folly 2021.03.29.00

* Wed Mar 24 2021 Michel Alexandre Salim <salimma@fedoraproject.org> - 1.32.1910230-4.20210312git97a8c0a
- Rebuild against folly 2021.03.22.00

* Mon Mar 15 2021 Michel Alexandre Salim <salimma@fedoraproject.org> - 1.32.1910230-3.20210312git97a8c0a
- Update to 20210312

* Tue Mar  9 2021 Davide Cavalca <dcavalca@fedoraproject.org> - 1.32.1910230-2.20210128git6aec23c
- Fix typos in summary
- Use more strict globbing for the soname version

* Thu Jan 28 2021 Davide Cavalca <dcavalca@fedoraproject.org> - 1.32.1910230-1.20210128git6aec23c
- Bump git commit to include upstream fixes
- Use system folly instead of bundling it
- Default to shared library build
- Use %%cmake instead of %%cmake3
- Use %%bcond for tests and turn off by default due to flakiness
- Update BuildRequires and Requires

* Sat Nov 07 2020 Nicolas Chauvet <kwizart@gmail.com> - 1.32.1910230-2.20200909gitb585d21
- Improve description
- Add --with tests conditional for tests
- Switch to cmake3
- And ExcludeArch inherited from folly

* Fri Oct 23 2020 Nicolas Chauvet <kwizart@gmail.com> - 1.32.1910230-1.20200909gitb585d21
- Update to 1.32.1910230 snapshot

* Tue Dec 19 2017 Kees de Jong <keesdejong@fedoraproject.org> - 1.27.1612021-1
- Initial package

